unit LoadModules;


interface
Uses
  BoxFiles,
  BoxAPI,
  MyTypes,
  Windows;

Procedure LoadLoadModules(Box: PBox);
Procedure UnLoadLoadModules(LoadModule: PLoadModule);

implementation

Function ModuleWndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Begin
  Result := DefWindowProcA(Wnd,Msg,wParam,lParam);
End;

Procedure LoadLoadModules(Box: PBox);
Var
  Buffer: String;
  LoadModule: PLoadModule;
//  wc: TWndClass;

Begin
  //Box^.First_Module := nil;

  Buffer := BoxReadNextConfig(Box^.BoxPtr,'*LoadModule');
    While Buffer<>'' do
      Begin
        New(LoadModule);

        LoadModule^.Next_Module := Box^.First_Module;
        Box^.First_LoadModule := LoadModule;

        With LoadModule^ Do
        Begin
          ModuleHandle := LoadLibrary( PChar(GetToken(Buffer,1) ));

          If ModuleHandle = 0 then
            ModuleHandle := LoadLibrary( PChar(LsPath+'\'+GetToken(Buffer,1) ));

          If ModuleHandle <> 0 then
          Begin

            initModule := GetProcAddress( ModuleHandle, 'initModuleEx' );
            quitModule := GetProcAddress( ModuleHandle, 'quitModule' );

            If (@initModule <> nil) then
              initModule( GetLitestepWnd, Inst, PCHAR(LsPath) );

          End
          Else
            MsgBox(MB_ICONWARNING,'Can''t load LoadModule:'+#13+GetToken(Buffer,1));

        End;

        Buffer := BoxReadNextConfig(Box^.BoxPtr,'*LoadModule');
      End;
End;

Procedure UnLoadLoadModules(LoadModule: PLoadModule);
Begin
 If ( LoadModule<>nil) then
  With LoadModule^ Do
  Begin
    If ModuleHandle <> 0 then
      Begin
        If (@quitModule <> nil) then
          quitModule(Inst);
        FreeLibrary(ModuleHandle);
      End;
      UnLoadLoadModules(Next_Module);
      Dispose(LoadModule);
  End;
End;

end.
