unit MyTypes;

Interface
Uses
  Windows;

Const
  revision = '3.0i';
  revId = 'Id: LsBox.dpr,v '+Revision+' 2004/03/11 blkhawk/Seg@';

  WM_CREATE = $0001;
  WM_DESTROY = $0002;
  WM_MOVE = $0003;
  WM_ACTIVATE = $0006;
  WM_PAINT = $000F;
  WM_SHOWWINDOW = $0018;
  WM_ERASEBKGND = $0014;
  WM_MOUSEACTIVATE = $0021;
  WM_CHILDACTIVATE = $0022;
  WM_WINDOWPOSCHANGING = $0046;
  WM_NCHITTEST = $0084;
  WM_TIMER = $0113;
  WM_MOUSEMOVE = $0200;
  WM_LBUTTONDOWN = $0201;
  WM_LBUTTONUP = $0202;
  WM_RBUTTONUP = $0205;
  WM_RBUTTONDOWN = $0204;
  WM_SYSCOMMAND = $0112;
  WM_EXITSIZEMOVE  = $0232;
  WM_DROPFILES = $0233;
  WM_MOUSELEAVE = $02A3;
  WM_USER = $0400;
  WM_MOVING = 534;
  BM_COMMAND = WM_USER+92;
  BM_DOCK = WM_USER+93;
  BM_UNDOCK = WM_USER+94;
  BM_DROPPED = WM_USER+95;
  BM_MOVEBOX = WM_USER+97;
  TME_LEAVE = $00000002;
  TTS_ALWAYSTIP = $01;
  TTF_SUBCLASS = $0010;
  TTM_DELTOOL = WM_USER + 5;
  LM_GETREVID = 9265;
  LM_REGISTERMESSAGE = 9263;
  LM_UNREGISTERMESSAGE = 9264;
  MAX_LINE_LENGTH = 4096;
  MAX_PATH = 260;


  lsapidll = 'LsApi.dll';
  user32dll = 'User32.dll';
  shell32 = 'shell32.dll';
  //Flags
  Moveing     = 1;
  Resizeable  = 2;
  Minimized   = 4;
  Hidden      = 8;
  UseFX       = 16;
  AlphaTransparent = 32;
  RememberDimensions = 64;
  isDocked = 128;
  HugBottom = 256;
  AutoHide = 512;
  noBackground = 1024;

  WS_EX_NOINHERITLAYOUT = $00100000;
  WS_EX_LAYERED = $80000;
  LWA_COLORKEY = $00000001;
  LWA_ALPHA = $00000002;

  AW_SLIDE = $40000;
  AW_ACTIVATE = $20000;
  AW_BLEND = $80000;
  AW_HIDE = $10000;
  AW_CENTER = $10;
  AW_HOR_POSITIVE = $1;  {left}
  AW_HOR_NEGATIVE = $2;  {right}
  AW_VER_POSITIVE = $4;  {up}
  AW_VER_NEGATIVE = $8;  {down}

Type
  HDROP = Longint;

 windowType=record
    Handle  :HWnd;
    Visible :Bool;
    Position:TRect;
  end;

  PwharfDataType= ^wharfDataType;
  wharfDataType= packed record
    borderSize      :Longint;
    pos             :Longint;
    winListSize     :Longint;
    winList         :^windowType;
    trayIconSize    :Longint;
    lm78Unit        :Longint;
    lm78MaxCPU      :Longint;
    lm78MaxMb       :Longint;
    lm78CPU         :Longint;
    taskBar         :Longint;
    msTaskBar       :Longint;
    taskBarFore     :Longint;
    taskBarBack     :Longint;
    taskbarText     :Longint;
    vwmVelocity     :Longint;
    autoHideWharf   :Longint;
    autoHideTaskBar :Longint;
    vwmDistance     :Longint;
    autoHideDelay   :Longint;
    showBeta        :Longint;
    usClock         :Longint;
    VWMNoGathering  :Longint;
    VWMNoAuto       :Longint;
    xmouseDelay     :Longint;
    xmouseBringToTop:Longint;
    pixmapDir       :PChar;
    defaultBmp      :PChar;
    vwmBackColor    :Longint;
    vwmSelBackColor :Longint;
    vwmForeColor    :Longint;
    vwmBorderColor  :Longint;
    backsaver       :PChar;
    taskBarFore2    :Longint;
    stripBar        :Longint;
    lsPath          :PChar;
  end;

  TTrackMouseEvent = record
    cbSize: DWORD;
    dwFlags: DWORD;
    hwndTrack: HWND;
    dwHoverTime: DWORD;
  end;

  //Toolinfo declaration for tooltips
  PToolInfo = ^TToolInfo;
  TToolInfo = packed record
    cbSize: UINT;
    uFlags: UINT;
    hwnd: HWND;
    uId: UINT;
    Rect: TRect;
    hInst: THandle;
    lpszText: PAnsiChar;
  end;

  TCutState = (Normal,Over,Click);

  PBox = ^TBox;

  PDockedBox = ^TDockedBox;
  TDockedBox = record
                 fBox: PBox;
                 xOffs,yOffs: integer;
                 Prev_DockedBox,
                 Next_DockedBox: PDockedBox;
               end;

  // Group
  PGroup = ^TGroup;
  TGroup = Record
             Id: integer;
             Flags: Word;
             First_Item: Pointer;
             Next_Group,
             Prev_Group: PGroup;
           End;
  // Group Item
  PGroupItem = ^TGroupItem;
  TGroupItem = Record
                 Wnd: HWND;
                 Group: PGroup;
                 Next_Item,
                 Prev_Item: PGroupItem;
               End;

  //Module type declaration
  PWharfModule = ^TWharfModule;
  TWharfModule = Record
                   M_Wnd: HWND;
                   xPos, yPos, Height, Width,
                   ModuleHandle: Integer;
                   InitModule : Function (Parent: HWND; inst: Integer; Wd: PWharfdataType):Integer; cdecl;
                   QuitModule : Procedure (inst: Integer); cdecl;
                   Next_Module: PWharfModule;
                   GroupItem: PGroupItem;
                 End;

  //Module type declaration
  PModule = ^TModule;
  TModule = Record
              ModuleHandle: Integer;
              InitModule : Function (Parent: HWND; inst: Integer; Cfg: PChar):Integer; cdecl;
              QuitModule : Procedure (inst: Integer); cdecl;
              Next_Module: PModule;
            End;

  //Module type declaration
  PLoadModule = ^TLoadModule;
  TLoadModule = Record
              ModuleHandle: Integer;
              InitModule : Function (Parent: HWND; inst: Integer; szPath: PChar):Integer; cdecl;
              QuitModule : Procedure (inst: Integer); cdecl;
              Next_Module: PLoadModule;
            End;

  //Shortcut type declaration
  PShortcut = ^TShortcut;
  TShortcut = Record
                DC_0, DC_1, DC_2, DC_3: HDC;
                RGN_0, RGN_1, RGN_2, RGN_3: HRGN;
                Swnd, xPos, yPos,
                Height, Width: Integer;
                CutState: TCutState;
                Command,RCommand: String;
                GroupItem: PGroupItem;
                Floating,
                DropTarget,
                OnTop: Boolean;
                Next_Shortcut: PShortcut; //Pointer to the next shortcut
                FBox: PBox; //Pointer to the parent box
              End;

  //The Main config list
  TBox = Record
           hMainWnd: HWND; BackDC: HDC;
           BackSkin: hBitmap;
           xPos, yPos, Height, Width, FX, FXDelay: Integer;
           SnapRect, Border: TRect;
           DragRGN: HRGN;
           LeftClickBang, RightClickBang,
           OnEnterBang, OnLeaveBang, Title: String;
           First_Shortcut, First_Module,First_Loadmodule,
           First_DockedBox, First_WharfModule: Pointer;
           DockedToBox,Next_Box, Prev_Box: PBox;
           BoxPtr: Pointer;
           BoxFile: String;
           FxEnabled, TrackMouse: Boolean;
           ActTrans, InActTrans: Byte;
           Stretched: Boolean;
           bgWidth, bgHeight: integer;
           Flags: word;
         End;

Var
  //Globale Variabelen
  Parent_Wnd: HWND;
  Hint_HWND: HWND = 0; //global ToolTip Handler
  Command_HWND: HWND = 0; //global Command Handeling
  First_Box: PBox = nil;
  First_Group: Pointer = nil;
  xOffs, yOffs : Integer;
  LsPath: String;
  Inst: longint;
  LSDskWnd: HWND;
  ScreenX, ScreenY: Integer;

Implementation

End.